#ifndef EFL_GENERATED_ECORE_ANIMATOR_HH
#define EFL_GENERATED_ECORE_ANIMATOR_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_animator.eo.h"
}

#include <Ecore.h>

namespace ecore {

struct animator
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit animator(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit animator(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Constructor.
   ///
   /// @param runtime 
   /// @param func 
   /// @param data 
   ///
   template <typename F>
   animator(double runtime_, F && func_, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : animator(_c0(runtime_, std::forward<F>(func_), _p))
   {}

   /// @brief Constructor.
   ///
   /// @param func 
   /// @param data 
   ///
   template <typename F>
   animator(F && func_, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : animator(_c1(std::forward<F>(func_), _p))
   {}

   /// @brief Copy Constructor.
   ///
   animator(animator const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~animator() {}

   /// @brief freeze events of object.
   /// Prevents event callbacks from being called for the object.
   ///
   void event_freeze() const
   {
      eo_do(_eo_ptr(), ::eo_event_freeze());
   }

   /// @brief thaw events of object.
   /// Lets event callbacks be called for the object.
   ///
   void event_thaw() const
   {
      eo_do(_eo_ptr(), ::eo_event_thaw());
   }

   static Eo_Class const* _eo_class()
   {
      return(ECORE_ANIMATOR_CLASS);
   }

private:
   template <typename F>
   static Eo* _c0(double runtime_, F && func_, efl::eo::parent_type _p)
   {
      typedef typename std::remove_reference<F>::type function_type;
function_type* _tmp_f = new F(std::forward<F>(func_));
      return eo_add_ref(ECORE_ANIMATOR_CLASS, _p._eo_raw, ecore_animator_timeline_constructor(runtime_, efl::eolian::get_callback<Ecore_Timeline_Cb, function_type>(), _tmp_f));
   }

   template <typename F>
   static Eo* _c1(F && func_, efl::eo::parent_type _p)
   {
      typedef typename std::remove_reference<F>::type function_type;
function_type* _tmp_f = new F(std::forward<F>(func_));
      return eo_add_ref(ECORE_ANIMATOR_CLASS, _p._eo_raw, ecore_animator_constructor(efl::eolian::get_callback<Ecore_Task_Cb, function_type>(), _tmp_f));
   }

};
} 

template <typename T>
void ecore_animator_event_freeze_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->event_freeze();
}

template <typename T>
void ecore_animator_event_thaw_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->event_thaw();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ecore::animator >
{
   template <typename T>
   struct type
   {
      virtual void event_freeze()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::eo_event_freeze());
      }

      virtual void event_thaw()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::eo_event_thaw());
      }

   };
};


template<>
struct operation_description_class_size< ecore::animator >
{
   static const int value = 2;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<ecore::animator>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::ecore_animator_event_freeze_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::eo_event_freeze);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::ecore_animator_event_thaw_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::eo_event_thaw);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ecore::animator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<ecore::animator, ::std::tuple<double, Ecore_Timeline_Cb, const void *> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::ecore_animator_timeline_constructor(::efl::eolian::to_c(args.get<0>()), ::efl::eolian::to_c(args.get<1>()), ::efl::eolian::to_c(args.get<2>())));
}

inline void
call_constructor(tag< ecore::animator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<ecore::animator, ::std::tuple<Ecore_Task_Cb, const void *> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::ecore_animator_constructor(::efl::eolian::to_c(args.get<0>()), ::efl::eolian::to_c(args.get<1>())));
}

inline void
call_constructor(tag< ecore::animator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<ecore::animator, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ecore::animator>
{
   template <typename U>
   struct type
   {
      operator ecore::animator() const
      {
         return ecore::animator(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void event_freeze()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::eo_event_freeze());
      }

      void event_thaw()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::eo_event_thaw());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<ecore::animator>)
{
   return (ECORE_ANIMATOR_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_ANIMATOR_HH

